/* This file is part of kmobiletools.
   See COPYING file for licensing information.

   (C) 2005 Marco Gulino <marco.gulino@gmail.com>
   (C) 2005 Stefan Bogner <bochi@kmobiletools.org>

*/


#ifndef MEMORYJOBS_H
#define MEMORYJOBS_H

#include "kmobiletoolsengine.h"
#include "kmobiletoolsgammu_engine.h"
#include "qphoneerror.h"
#include "gammu_jobs.h"
#include "contactptrlist.h"

#include <qptrlist.h>
#include <kabc/addressee.h>
#include <qptrvector.h>

extern "C" {
    #include <gammu/gammu.h>
}
#undef bool

class Device;
class QStringList;
class kmobiletoolsGammu_engine;


class FetchMemory : public kmobiletoolsGammuJob
{
    public:
        FetchMemory ( Device *dev, kmobiletoolsGammu_engine* parent = 0 , const char* name = 0 );
        ContactPtrList addresseeList;
        int type()            { return kmobiletoolsJob::fetchAddressBook; }
        QValueList<GSM_MemoryEntry> freeEntries;
    protected:
        void run ();
        void getPbk( GSM_MemoryType );
        int getFreeSlot( GSM_MemoryType );
        void delEntry( KABC::Addressee * );
        void addEntry( KABC::Addressee *, GSM_MemoryType, int slot = 0 );
        KABC::Addressee* pbk2kabc( GSM_MemoryEntry );
        GSM_MemoryEntry kabc2pbk( KABC::Addressee * );
    private:
        KABC::Addressee *p_addressee;
        GSM_MemoryStatus m;
        GSM_MemoryEntry Entry;
        QPhoneError err;

};

class EditPbk :  public kmobiletoolsGammuJob
{
    public:
        EditPbk( QValueList<KABC::Addressee> *abclist, Device *device, bool b_todelete=FALSE, kmobiletoolsGammu_engine *parent=0, const char *name = 0, GSM_MemoryType memtype = MEM_ME );
        
        EditPbk(  KABC::Addressee *oldAddressee, KABC::Addressee *newAddressee, Device *device, kmobiletoolsGammu_engine *parent=0, const char *name = 0);
        
        int type() { return kmobiletoolsJob::delAddressee; }

    protected:
        void run();
        //GSM_MemoryEntry EditPbk::kabc2pbk( KABC::Addressee* );
        void addEntry( KABC::Addressee*, GSM_MemoryType, int );
        void delEntry( KABC::Addressee* );
    private:
        QValueList<KABC::Addressee> *p_abclist;
        KABC::Addressee *p_oldAddressee;
        KABC::Addressee *p_newAddressee;
        bool todelete;
        GSM_MemoryStatus m;
        GSM_MemoryEntry Entry;
        GSM_MemoryType p_memType;
        QPhoneError err;
};

#endif
